/* This is an autogenerated file from from sme__fsm_signal_gen.pl */
/* Tag: noCheckHeader */

/*    CONFIDENTIAL */
/*    Copyright (C) Cambridge Silicon Radio Ltd 2008. All rights reserved. */

/* This is an autogenerated file from sme___fsm_signal_gen.pl */


#ifndef SME_SIGNALS_XML_SIGNALS_H
#define SME_SIGNALS_XML_SIGNALS_H

/* defines for BT_SIGNALS */

#define UNIFI_BT_UNICORE_INIT_REQ_ID                        0x7001
#define UNIFI_BT_UNICORE_INIT_IND_ID                        0x7002
#define UNIFI_BT_UNICORE_FINAL_REQ_ID                       0x7003
#define UNIFI_BT_UNICORE_FINAL_IND_ID                       0x7004
#define UNIFI_BT_UNICORE_PING_REQ_ID                        0x7005
#define UNIFI_BT_UNICORE_PING_IND_ID                        0x7006
#define UNIFI_BT_UNICORE_PONG_REQ_ID                        0x7007
#define UNIFI_BT_UNICORE_PONG_IND_ID                        0x7008
#define UNIFI_BT_UNICORE_ACTIVE_DOT11_CHANNEL_REQ_ID        0x7009
#define UNIFI_BT_UNICORE_PASS_SYNC_START_IND_ID             0x700A
#define UNIFI_BT_UNICORE_PASS_SYNC_CHANGE_IND_ID            0x700B
#define UNIFI_BT_UNICORE_PASS_SYNC_STOP_IND_ID              0x700C

/* defines for DBG_SIGNALS */

#define UNIFI_DBG_SET_ALL_LEVELS_REQ_ID                     0x1900
#define UNIFI_DBG_SET_LEVEL_REQ_ID                          0x1901
#define UNIFI_DBG_GET_LEVEL_REQ_ID                          0x1902
#define UNIFI_DBG_GET_LEVEL_CFM_ID                          0x1903
#define UNIFI_DBG_EXIT_REQ_ID                               0x1904
#define UNIFI_DBG_CMD_REQ_ID                                0x1905

/* defines for MGT_SIGNALS */

#define UNIFI_MGT_WIFI_ON_REQ_ID                            0x9001
#define UNIFI_MGT_WIFI_ON_CFM_ID                            0x9002
#define UNIFI_MGT_WIFI_OFF_REQ_ID                           0x9003
#define UNIFI_MGT_WIFI_OFF_CFM_ID                           0x9004
#define UNIFI_MGT_WIFI_OFF_IND_ID                           0x9005
#define UNIFI_MGT_WIFI_FLIGHTMODE_REQ_ID                    0x9006
#define UNIFI_MGT_WIFI_FLIGHTMODE_CFM_ID                    0x9007
#define UNIFI_MGT_SET_VALUE_REQ_ID                          0x9008
#define UNIFI_MGT_SET_VALUE_CFM_ID                          0x9009
#define UNIFI_MGT_GET_VALUE_REQ_ID                          0x900A
#define UNIFI_MGT_GET_VALUE_CFM_ID                          0x900B
#define UNIFI_MGT_MIB_SET_REQ_ID                            0x900C
#define UNIFI_MGT_MIB_SET_CFM_ID                            0x900D
#define UNIFI_MGT_MIB_GET_REQ_ID                            0x900E
#define UNIFI_MGT_MIB_GET_CFM_ID                            0x900F
#define UNIFI_MGT_MIB_GET_NEXT_REQ_ID                       0x9010
#define UNIFI_MGT_MIB_GET_NEXT_CFM_ID                       0x9011
#define UNIFI_MGT_SCAN_FULL_REQ_ID                          0x9012
#define UNIFI_MGT_SCAN_FULL_CFM_ID                          0x9013
#define UNIFI_MGT_SCAN_RESULTS_GET_REQ_ID                   0x9014
#define UNIFI_MGT_SCAN_RESULTS_GET_CFM_ID                   0x9015
#define UNIFI_MGT_SCAN_RESULT_IND_ID                        0x9016
#define UNIFI_MGT_CONNECT_REQ_ID                            0x9017
#define UNIFI_MGT_CONNECT_CFM_ID                            0x9018
#define UNIFI_MGT_MEDIA_STATUS_IND_ID                       0x9019
#define UNIFI_MGT_CONNECTION_QUALITY_IND_ID                 0x901A
#define UNIFI_MGT_DISCONNECT_REQ_ID                         0x901B
#define UNIFI_MGT_DISCONNECT_CFM_ID                         0x901C
#define UNIFI_MGT_MULTICAST_ADDRESS_REQ_ID                  0x901D
#define UNIFI_MGT_MULTICAST_ADDRESS_CFM_ID                  0x901E
#define UNIFI_MGT_MIC_FAILURE_IND_ID                        0x901F
#define UNIFI_MGT_PMKID_CANDIDATE_LIST_IND_ID               0x9020
#define UNIFI_MGT_PMKID_REQ_ID                              0x9021
#define UNIFI_MGT_PMKID_CFM_ID                              0x9022
#define UNIFI_MGT_KEY_REQ_ID                                0x9023
#define UNIFI_MGT_KEY_CFM_ID                                0x9024
#define UNIFI_MGT_PACKET_FILTER_SET_REQ_ID                  0x9025
#define UNIFI_MGT_PACKET_FILTER_SET_CFM_ID                  0x9026
#define UNIFI_MGT_TSPEC_REQ_ID                              0x9027
#define UNIFI_MGT_TSPEC_CFM_ID                              0x9028
#define UNIFI_MGT_TSPEC_IND_ID                              0x9029

/* defines for SYS_SIGNALS */

#define UNIFI_SYS_WIFI_ON_REQ_ID                            0x8001
#define UNIFI_SYS_WIFI_ON_IND_ID                            0x8002
#define UNIFI_SYS_WIFI_ON_RSP_ID                            0x8003
#define UNIFI_SYS_WIFI_ON_CFM_ID                            0x8004
#define UNIFI_SYS_WIFI_OFF_REQ_ID                           0x8005
#define UNIFI_SYS_WIFI_OFF_IND_ID                           0x8006
#define UNIFI_SYS_WIFI_OFF_RSP_ID                           0x8007
#define UNIFI_SYS_WIFI_OFF_CFM_ID                           0x8008
#define UNIFI_SYS_SUSPEND_IND_ID                            0x8009
#define UNIFI_SYS_SUSPEND_RSP_ID                            0x800A
#define UNIFI_SYS_RESUME_IND_ID                             0x800B
#define UNIFI_SYS_RESUME_RSP_ID                             0x800C
#define UNIFI_SYS_HIP_REQ_ID                                0x800D
#define UNIFI_SYS_HIP_IND_ID                                0x800E
#define UNIFI_SYS_QOS_CONTROL_REQ_ID                        0x800F
#define UNIFI_SYS_QOS_CONTROL_CFM_ID                        0x8010
#define UNIFI_SYS_PORT_CONFIGURE_REQ_ID                     0x8011
#define UNIFI_SYS_PORT_CONFIGURE_CFM_ID                     0x8012
#define UNIFI_SYS_CONFIGURE_POWER_MODE_REQ_ID               0x8013
#define UNIFI_SYS_TRAFFIC_CONFIG_REQ_ID                     0x8014
#define UNIFI_SYS_TRAFFIC_SAMPLE_IND_ID                     0x8015
#define UNIFI_SYS_TRAFFIC_PROTOCOL_IND_ID                   0x8016
#define UNIFI_SYS_IP_CONFIGURED_IND_ID                      0x8017
#define UNIFI_SYS_MEDIA_STATUS_REQ_ID                       0x8018
#define UNIFI_SYS_MULTICAST_ADDRESS_IND_ID                  0x8019
#define UNIFI_SYS_MULTICAST_ADDRESS_RSP_ID                  0x801A
#define UNIFI_SYS_TCLAS_ADD_REQ_ID                          0x801B
#define UNIFI_SYS_TCLAS_ADD_CFM_ID                          0x801C
#define UNIFI_SYS_TCLAS_DEL_REQ_ID                          0x801D
#define UNIFI_SYS_TCLAS_DEL_CFM_ID                          0x801E
#define UNIFI_SYS_TRAFFIC_CLASSIFICATION_REQ_ID             0x801F

/* -------------------------- UNIFI_BT_UNICORE_INIT.request -------------------------- */
typedef struct UnifiBtUnicoreInitReq_Evt
{
    FsmEvent common;
    uint16 minVersion;
    uint16 maxVersion;
    Boolean reply;
} UnifiBtUnicoreInitReq_Evt;

#define send_unifi_bt_unicore_init_req(context, pid, p1_minVersion, p2_maxVersion, p3_reply) \
{ \
    UnifiBtUnicoreInitReq_Evt *evt = (UnifiBtUnicoreInitReq_Evt*) osa_malloc(sizeof(UnifiBtUnicoreInitReq_Evt));\
    evt->minVersion = p1_minVersion;\
    evt->maxVersion = p2_maxVersion;\
    evt->reply = p3_reply;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_INIT_REQ_ID);\
}

#define send_unifi_bt_unicore_init_req_external(context, pid, p1_minVersion, p2_maxVersion, p3_reply) \
{ \
    UnifiBtUnicoreInitReq_Evt *evt = (UnifiBtUnicoreInitReq_Evt*) osa_malloc(sizeof(UnifiBtUnicoreInitReq_Evt));\
    evt->minVersion = p1_minVersion;\
    evt->maxVersion = p2_maxVersion;\
    evt->reply = p3_reply;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_INIT_REQ_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_INIT.indication -------------------------- */
typedef struct UnifiBtUnicoreInitInd_Evt
{
    FsmEvent common;
    uint16 minVersion;
    uint16 maxVersion;
    Boolean reply;
} UnifiBtUnicoreInitInd_Evt;

#define send_unifi_bt_unicore_init_ind(context, pid, p1_minVersion, p2_maxVersion, p3_reply) \
{ \
    UnifiBtUnicoreInitInd_Evt *evt = (UnifiBtUnicoreInitInd_Evt*) osa_malloc(sizeof(UnifiBtUnicoreInitInd_Evt));\
    evt->minVersion = p1_minVersion;\
    evt->maxVersion = p2_maxVersion;\
    evt->reply = p3_reply;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_INIT_IND_ID);\
}

#define send_unifi_bt_unicore_init_ind_external(context, pid, p1_minVersion, p2_maxVersion, p3_reply) \
{ \
    UnifiBtUnicoreInitInd_Evt *evt = (UnifiBtUnicoreInitInd_Evt*) osa_malloc(sizeof(UnifiBtUnicoreInitInd_Evt));\
    evt->minVersion = p1_minVersion;\
    evt->maxVersion = p2_maxVersion;\
    evt->reply = p3_reply;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_INIT_IND_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_FINAL.request -------------------------- */
typedef struct UnifiBtUnicoreFinalReq_Evt
{
    FsmEvent common;
} UnifiBtUnicoreFinalReq_Evt;

#define send_unifi_bt_unicore_final_req(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_BT_UNICORE_FINAL_REQ_ID);\
}

#define send_unifi_bt_unicore_final_req_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_BT_UNICORE_FINAL_REQ_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_FINAL.indication -------------------------- */
typedef struct UnifiBtUnicoreFinalInd_Evt
{
    FsmEvent common;
} UnifiBtUnicoreFinalInd_Evt;

#define send_unifi_bt_unicore_final_ind(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_BT_UNICORE_FINAL_IND_ID);\
}

#define send_unifi_bt_unicore_final_ind_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_BT_UNICORE_FINAL_IND_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_PING.request -------------------------- */
typedef struct UnifiBtUnicorePingReq_Evt
{
    FsmEvent common;
    uint16 tag;
} UnifiBtUnicorePingReq_Evt;

#define send_unifi_bt_unicore_ping_req(context, pid, p1_tag) \
{ \
    UnifiBtUnicorePingReq_Evt *evt = (UnifiBtUnicorePingReq_Evt*) osa_malloc(sizeof(UnifiBtUnicorePingReq_Evt));\
    evt->tag = p1_tag;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PING_REQ_ID);\
}

#define send_unifi_bt_unicore_ping_req_external(context, pid, p1_tag) \
{ \
    UnifiBtUnicorePingReq_Evt *evt = (UnifiBtUnicorePingReq_Evt*) osa_malloc(sizeof(UnifiBtUnicorePingReq_Evt));\
    evt->tag = p1_tag;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PING_REQ_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_PING.indication -------------------------- */
typedef struct UnifiBtUnicorePingInd_Evt
{
    FsmEvent common;
    uint16 tag;
} UnifiBtUnicorePingInd_Evt;

#define send_unifi_bt_unicore_ping_ind(context, pid, p1_tag) \
{ \
    UnifiBtUnicorePingInd_Evt *evt = (UnifiBtUnicorePingInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePingInd_Evt));\
    evt->tag = p1_tag;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PING_IND_ID);\
}

#define send_unifi_bt_unicore_ping_ind_external(context, pid, p1_tag) \
{ \
    UnifiBtUnicorePingInd_Evt *evt = (UnifiBtUnicorePingInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePingInd_Evt));\
    evt->tag = p1_tag;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PING_IND_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_PONG.request -------------------------- */
typedef struct UnifiBtUnicorePongReq_Evt
{
    FsmEvent common;
    uint16 tag;
} UnifiBtUnicorePongReq_Evt;

#define send_unifi_bt_unicore_pong_req(context, pid, p1_tag) \
{ \
    UnifiBtUnicorePongReq_Evt *evt = (UnifiBtUnicorePongReq_Evt*) osa_malloc(sizeof(UnifiBtUnicorePongReq_Evt));\
    evt->tag = p1_tag;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PONG_REQ_ID);\
}

#define send_unifi_bt_unicore_pong_req_external(context, pid, p1_tag) \
{ \
    UnifiBtUnicorePongReq_Evt *evt = (UnifiBtUnicorePongReq_Evt*) osa_malloc(sizeof(UnifiBtUnicorePongReq_Evt));\
    evt->tag = p1_tag;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PONG_REQ_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_PONG.indication -------------------------- */
typedef struct UnifiBtUnicorePongInd_Evt
{
    FsmEvent common;
    uint16 tag;
} UnifiBtUnicorePongInd_Evt;

#define send_unifi_bt_unicore_pong_ind(context, pid, p1_tag) \
{ \
    UnifiBtUnicorePongInd_Evt *evt = (UnifiBtUnicorePongInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePongInd_Evt));\
    evt->tag = p1_tag;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PONG_IND_ID);\
}

#define send_unifi_bt_unicore_pong_ind_external(context, pid, p1_tag) \
{ \
    UnifiBtUnicorePongInd_Evt *evt = (UnifiBtUnicorePongInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePongInd_Evt));\
    evt->tag = p1_tag;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PONG_IND_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_ACTIVE_DOT11_CHANNEL.request -------------------------- */
typedef struct UnifiBtUnicoreActiveDot11ChannelReq_Evt
{
    FsmEvent common;
    uint16 channelMhz;
    uint16 bandwidthMhz;
} UnifiBtUnicoreActiveDot11ChannelReq_Evt;

#define send_unifi_bt_unicore_active_dot11_channel_req(context, pid, p1_channelMhz, p2_bandwidthMhz) \
{ \
    UnifiBtUnicoreActiveDot11ChannelReq_Evt *evt = (UnifiBtUnicoreActiveDot11ChannelReq_Evt*) osa_malloc(sizeof(UnifiBtUnicoreActiveDot11ChannelReq_Evt));\
    evt->channelMhz = p1_channelMhz;\
    evt->bandwidthMhz = p2_bandwidthMhz;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_ACTIVE_DOT11_CHANNEL_REQ_ID);\
}

#define send_unifi_bt_unicore_active_dot11_channel_req_external(context, pid, p1_channelMhz, p2_bandwidthMhz) \
{ \
    UnifiBtUnicoreActiveDot11ChannelReq_Evt *evt = (UnifiBtUnicoreActiveDot11ChannelReq_Evt*) osa_malloc(sizeof(UnifiBtUnicoreActiveDot11ChannelReq_Evt));\
    evt->channelMhz = p1_channelMhz;\
    evt->bandwidthMhz = p2_bandwidthMhz;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_ACTIVE_DOT11_CHANNEL_REQ_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_PASS_SYNC_START.indication -------------------------- */
typedef struct UnifiBtUnicorePassSyncStartInd_Evt
{
    FsmEvent common;
    uint16 connectionHandle;
    uint16 period;
    uint16 durationMin;
    uint16 durationMax;
} UnifiBtUnicorePassSyncStartInd_Evt;

#define send_unifi_bt_unicore_pass_sync_start_ind(context, pid, p1_connectionHandle, p2_period, p3_durationMin, p4_durationMax) \
{ \
    UnifiBtUnicorePassSyncStartInd_Evt *evt = (UnifiBtUnicorePassSyncStartInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePassSyncStartInd_Evt));\
    evt->connectionHandle = p1_connectionHandle;\
    evt->period = p2_period;\
    evt->durationMin = p3_durationMin;\
    evt->durationMax = p4_durationMax;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PASS_SYNC_START_IND_ID);\
}

#define send_unifi_bt_unicore_pass_sync_start_ind_external(context, pid, p1_connectionHandle, p2_period, p3_durationMin, p4_durationMax) \
{ \
    UnifiBtUnicorePassSyncStartInd_Evt *evt = (UnifiBtUnicorePassSyncStartInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePassSyncStartInd_Evt));\
    evt->connectionHandle = p1_connectionHandle;\
    evt->period = p2_period;\
    evt->durationMin = p3_durationMin;\
    evt->durationMax = p4_durationMax;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PASS_SYNC_START_IND_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_PASS_SYNC_CHANGE.indication -------------------------- */
typedef struct UnifiBtUnicorePassSyncChangeInd_Evt
{
    FsmEvent common;
    uint16 connectionHandle;
    uint16 period;
    uint16 durationMin;
    uint16 durationMax;
} UnifiBtUnicorePassSyncChangeInd_Evt;

#define send_unifi_bt_unicore_pass_sync_change_ind(context, pid, p1_connectionHandle, p2_period, p3_durationMin, p4_durationMax) \
{ \
    UnifiBtUnicorePassSyncChangeInd_Evt *evt = (UnifiBtUnicorePassSyncChangeInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePassSyncChangeInd_Evt));\
    evt->connectionHandle = p1_connectionHandle;\
    evt->period = p2_period;\
    evt->durationMin = p3_durationMin;\
    evt->durationMax = p4_durationMax;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PASS_SYNC_CHANGE_IND_ID);\
}

#define send_unifi_bt_unicore_pass_sync_change_ind_external(context, pid, p1_connectionHandle, p2_period, p3_durationMin, p4_durationMax) \
{ \
    UnifiBtUnicorePassSyncChangeInd_Evt *evt = (UnifiBtUnicorePassSyncChangeInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePassSyncChangeInd_Evt));\
    evt->connectionHandle = p1_connectionHandle;\
    evt->period = p2_period;\
    evt->durationMin = p3_durationMin;\
    evt->durationMax = p4_durationMax;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PASS_SYNC_CHANGE_IND_ID);\
}

/* -------------------------- UNIFI_BT_UNICORE_PASS_SYNC_STOP.indication -------------------------- */
typedef struct UnifiBtUnicorePassSyncStopInd_Evt
{
    FsmEvent common;
    uint16 connectionHandle;
} UnifiBtUnicorePassSyncStopInd_Evt;

#define send_unifi_bt_unicore_pass_sync_stop_ind(context, pid, p1_connectionHandle) \
{ \
    UnifiBtUnicorePassSyncStopInd_Evt *evt = (UnifiBtUnicorePassSyncStopInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePassSyncStopInd_Evt));\
    evt->connectionHandle = p1_connectionHandle;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PASS_SYNC_STOP_IND_ID);\
}

#define send_unifi_bt_unicore_pass_sync_stop_ind_external(context, pid, p1_connectionHandle) \
{ \
    UnifiBtUnicorePassSyncStopInd_Evt *evt = (UnifiBtUnicorePassSyncStopInd_Evt*) osa_malloc(sizeof(UnifiBtUnicorePassSyncStopInd_Evt));\
    evt->connectionHandle = p1_connectionHandle;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_BT_UNICORE_PASS_SYNC_STOP_IND_ID);\
}

/* -------------------------- UNIFI_DBG_SET_ALL_LEVELS.request -------------------------- */
typedef struct UnifiDbgSetAllLevelsReq_Evt
{
    FsmEvent common;
    uint16 level;
} UnifiDbgSetAllLevelsReq_Evt;

#define send_unifi_dbg_set_all_levels_req(context, pid, p1_level) \
{ \
    UnifiDbgSetAllLevelsReq_Evt *evt = (UnifiDbgSetAllLevelsReq_Evt*) osa_malloc(sizeof(UnifiDbgSetAllLevelsReq_Evt));\
    evt->level = p1_level;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_DBG_SET_ALL_LEVELS_REQ_ID);\
}

#define send_unifi_dbg_set_all_levels_req_external(context, pid, p1_level) \
{ \
    UnifiDbgSetAllLevelsReq_Evt *evt = (UnifiDbgSetAllLevelsReq_Evt*) osa_malloc(sizeof(UnifiDbgSetAllLevelsReq_Evt));\
    evt->level = p1_level;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_DBG_SET_ALL_LEVELS_REQ_ID);\
}

/* -------------------------- UNIFI_DBG_SET_LEVEL.request -------------------------- */
typedef struct UnifiDbgSetLevelReq_Evt
{
    FsmEvent common;
    uint16 id;
    uint16 level;
} UnifiDbgSetLevelReq_Evt;

#define send_unifi_dbg_set_level_req(context, pid, p1_id, p2_level) \
{ \
    UnifiDbgSetLevelReq_Evt *evt = (UnifiDbgSetLevelReq_Evt*) osa_malloc(sizeof(UnifiDbgSetLevelReq_Evt));\
    evt->id = p1_id;\
    evt->level = p2_level;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_DBG_SET_LEVEL_REQ_ID);\
}

#define send_unifi_dbg_set_level_req_external(context, pid, p1_id, p2_level) \
{ \
    UnifiDbgSetLevelReq_Evt *evt = (UnifiDbgSetLevelReq_Evt*) osa_malloc(sizeof(UnifiDbgSetLevelReq_Evt));\
    evt->id = p1_id;\
    evt->level = p2_level;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_DBG_SET_LEVEL_REQ_ID);\
}

/* -------------------------- UNIFI_DBG_GET_LEVEL.request -------------------------- */
typedef struct UnifiDbgGetLevelReq_Evt
{
    FsmEvent common;
    uint16 id;
} UnifiDbgGetLevelReq_Evt;

#define send_unifi_dbg_get_level_req(context, pid, p1_id) \
{ \
    UnifiDbgGetLevelReq_Evt *evt = (UnifiDbgGetLevelReq_Evt*) osa_malloc(sizeof(UnifiDbgGetLevelReq_Evt));\
    evt->id = p1_id;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_DBG_GET_LEVEL_REQ_ID);\
}

#define send_unifi_dbg_get_level_req_external(context, pid, p1_id) \
{ \
    UnifiDbgGetLevelReq_Evt *evt = (UnifiDbgGetLevelReq_Evt*) osa_malloc(sizeof(UnifiDbgGetLevelReq_Evt));\
    evt->id = p1_id;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_DBG_GET_LEVEL_REQ_ID);\
}

/* -------------------------- UNIFI_DBG_GET_LEVEL.confirm -------------------------- */
typedef struct UnifiDbgGetLevelCfm_Evt
{
    FsmEvent common;
    uint16 id;
    uint16 level;
} UnifiDbgGetLevelCfm_Evt;

#define send_unifi_dbg_get_level_cfm(context, pid, p1_id, p2_level) \
{ \
    UnifiDbgGetLevelCfm_Evt *evt = (UnifiDbgGetLevelCfm_Evt*) osa_malloc(sizeof(UnifiDbgGetLevelCfm_Evt));\
    evt->id = p1_id;\
    evt->level = p2_level;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_DBG_GET_LEVEL_CFM_ID);\
}

#define send_unifi_dbg_get_level_cfm_external(context, pid, p1_id, p2_level) \
{ \
    UnifiDbgGetLevelCfm_Evt *evt = (UnifiDbgGetLevelCfm_Evt*) osa_malloc(sizeof(UnifiDbgGetLevelCfm_Evt));\
    evt->id = p1_id;\
    evt->level = p2_level;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_DBG_GET_LEVEL_CFM_ID);\
}

/* -------------------------- UNIFI_DBG_EXIT.request -------------------------- */
typedef struct UnifiDbgExitReq_Evt
{
    FsmEvent common;
} UnifiDbgExitReq_Evt;

#define send_unifi_dbg_exit_req(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_DBG_EXIT_REQ_ID);\
}

#define send_unifi_dbg_exit_req_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_DBG_EXIT_REQ_ID);\
}

/* -------------------------- UNIFI_DBG_CMD.request -------------------------- */
typedef struct UnifiDbgCmdReq_Evt
{
    FsmEvent common;
    unifi_String command;
} UnifiDbgCmdReq_Evt;

#define send_unifi_dbg_cmd_req(context, pid, p1_command) \
{ \
    UnifiDbgCmdReq_Evt *evt = (UnifiDbgCmdReq_Evt*) osa_malloc(sizeof(UnifiDbgCmdReq_Evt));\
    evt->command = p1_command;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_DBG_CMD_REQ_ID);\
}

#define send_unifi_dbg_cmd_req_external(context, pid, p1_command) \
{ \
    UnifiDbgCmdReq_Evt *evt = (UnifiDbgCmdReq_Evt*) osa_malloc(sizeof(UnifiDbgCmdReq_Evt));\
    evt->command = p1_command;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_DBG_CMD_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_WIFI_ON.request -------------------------- */
typedef struct UnifiMgtWifiOnReq_Evt
{
    FsmEvent common;
    unifi_MACAddress address;
    unifi_DataBlockList mibFiles;
} UnifiMgtWifiOnReq_Evt;

#define send_unifi_mgt_wifi_on_req(context, pid, p1_address, p2_mibFiles) \
{ \
    UnifiMgtWifiOnReq_Evt *evt = (UnifiMgtWifiOnReq_Evt*) osa_malloc(sizeof(UnifiMgtWifiOnReq_Evt));\
    evt->address = p1_address;\
    evt->mibFiles = p2_mibFiles;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_ON_REQ_ID);\
}

#define send_unifi_mgt_wifi_on_req_external(context, pid, p1_address, p2_mibFiles) \
{ \
    UnifiMgtWifiOnReq_Evt *evt = (UnifiMgtWifiOnReq_Evt*) osa_malloc(sizeof(UnifiMgtWifiOnReq_Evt));\
    evt->address = p1_address;\
    evt->mibFiles = p2_mibFiles;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_ON_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_WIFI_ON.confirm -------------------------- */
typedef struct UnifiMgtWifiOnCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiMgtWifiOnCfm_Evt;

#define send_unifi_mgt_wifi_on_cfm(context, pid, p1_status) \
{ \
    UnifiMgtWifiOnCfm_Evt *evt = (UnifiMgtWifiOnCfm_Evt*) osa_malloc(sizeof(UnifiMgtWifiOnCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_ON_CFM_ID);\
}

#define send_unifi_mgt_wifi_on_cfm_external(context, pid, p1_status) \
{ \
    UnifiMgtWifiOnCfm_Evt *evt = (UnifiMgtWifiOnCfm_Evt*) osa_malloc(sizeof(UnifiMgtWifiOnCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_ON_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_WIFI_OFF.request -------------------------- */
typedef struct UnifiMgtWifiOffReq_Evt
{
    FsmEvent common;
} UnifiMgtWifiOffReq_Evt;

#define send_unifi_mgt_wifi_off_req(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_MGT_WIFI_OFF_REQ_ID);\
}

#define send_unifi_mgt_wifi_off_req_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_MGT_WIFI_OFF_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_WIFI_OFF.confirm -------------------------- */
typedef struct UnifiMgtWifiOffCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiMgtWifiOffCfm_Evt;

#define send_unifi_mgt_wifi_off_cfm(context, pid, p1_status) \
{ \
    UnifiMgtWifiOffCfm_Evt *evt = (UnifiMgtWifiOffCfm_Evt*) osa_malloc(sizeof(UnifiMgtWifiOffCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_OFF_CFM_ID);\
}

#define send_unifi_mgt_wifi_off_cfm_external(context, pid, p1_status) \
{ \
    UnifiMgtWifiOffCfm_Evt *evt = (UnifiMgtWifiOffCfm_Evt*) osa_malloc(sizeof(UnifiMgtWifiOffCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_OFF_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_WIFI_OFF.indication -------------------------- */
typedef struct UnifiMgtWifiOffInd_Evt
{
    FsmEvent common;
    unifi_ControlIndication controlIndication;
} UnifiMgtWifiOffInd_Evt;

#define send_unifi_mgt_wifi_off_ind(context, pid, p1_controlIndication) \
{ \
    UnifiMgtWifiOffInd_Evt *evt = (UnifiMgtWifiOffInd_Evt*) osa_malloc(sizeof(UnifiMgtWifiOffInd_Evt));\
    evt->controlIndication = p1_controlIndication;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_OFF_IND_ID);\
}

#define send_unifi_mgt_wifi_off_ind_external(context, pid, p1_controlIndication) \
{ \
    UnifiMgtWifiOffInd_Evt *evt = (UnifiMgtWifiOffInd_Evt*) osa_malloc(sizeof(UnifiMgtWifiOffInd_Evt));\
    evt->controlIndication = p1_controlIndication;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_OFF_IND_ID);\
}

/* -------------------------- UNIFI_MGT_WIFI_FLIGHTMODE.request -------------------------- */
typedef struct UnifiMgtWifiFlightmodeReq_Evt
{
    FsmEvent common;
    unifi_MACAddress address;
    unifi_DataBlockList mibFiles;
} UnifiMgtWifiFlightmodeReq_Evt;

#define send_unifi_mgt_wifi_flightmode_req(context, pid, p1_address, p2_mibFiles) \
{ \
    UnifiMgtWifiFlightmodeReq_Evt *evt = (UnifiMgtWifiFlightmodeReq_Evt*) osa_malloc(sizeof(UnifiMgtWifiFlightmodeReq_Evt));\
    evt->address = p1_address;\
    evt->mibFiles = p2_mibFiles;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_FLIGHTMODE_REQ_ID);\
}

#define send_unifi_mgt_wifi_flightmode_req_external(context, pid, p1_address, p2_mibFiles) \
{ \
    UnifiMgtWifiFlightmodeReq_Evt *evt = (UnifiMgtWifiFlightmodeReq_Evt*) osa_malloc(sizeof(UnifiMgtWifiFlightmodeReq_Evt));\
    evt->address = p1_address;\
    evt->mibFiles = p2_mibFiles;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_FLIGHTMODE_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_WIFI_FLIGHTMODE.confirm -------------------------- */
typedef struct UnifiMgtWifiFlightmodeCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiMgtWifiFlightmodeCfm_Evt;

#define send_unifi_mgt_wifi_flightmode_cfm(context, pid, p1_status) \
{ \
    UnifiMgtWifiFlightmodeCfm_Evt *evt = (UnifiMgtWifiFlightmodeCfm_Evt*) osa_malloc(sizeof(UnifiMgtWifiFlightmodeCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_FLIGHTMODE_CFM_ID);\
}

#define send_unifi_mgt_wifi_flightmode_cfm_external(context, pid, p1_status) \
{ \
    UnifiMgtWifiFlightmodeCfm_Evt *evt = (UnifiMgtWifiFlightmodeCfm_Evt*) osa_malloc(sizeof(UnifiMgtWifiFlightmodeCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_WIFI_FLIGHTMODE_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_SET_VALUE.request -------------------------- */
typedef struct UnifiMgtSetValueReq_Evt
{
    FsmEvent common;
    unifi_AppValue appValue;
} UnifiMgtSetValueReq_Evt;

#define send_unifi_mgt_set_value_req(context, pid, p1_appValue) \
{ \
    UnifiMgtSetValueReq_Evt *evt = (UnifiMgtSetValueReq_Evt*) osa_malloc(sizeof(UnifiMgtSetValueReq_Evt));\
    evt->appValue = p1_appValue;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_SET_VALUE_REQ_ID);\
}

#define send_unifi_mgt_set_value_req_external(context, pid, p1_appValue) \
{ \
    UnifiMgtSetValueReq_Evt *evt = (UnifiMgtSetValueReq_Evt*) osa_malloc(sizeof(UnifiMgtSetValueReq_Evt));\
    evt->appValue = p1_appValue;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_SET_VALUE_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_SET_VALUE.confirm -------------------------- */
typedef struct UnifiMgtSetValueCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_AppValueId appValueId;
} UnifiMgtSetValueCfm_Evt;

#define send_unifi_mgt_set_value_cfm(context, pid, p1_status, p2_appValueId) \
{ \
    UnifiMgtSetValueCfm_Evt *evt = (UnifiMgtSetValueCfm_Evt*) osa_malloc(sizeof(UnifiMgtSetValueCfm_Evt));\
    evt->status = p1_status;\
    evt->appValueId = p2_appValueId;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_SET_VALUE_CFM_ID);\
}

#define send_unifi_mgt_set_value_cfm_external(context, pid, p1_status, p2_appValueId) \
{ \
    UnifiMgtSetValueCfm_Evt *evt = (UnifiMgtSetValueCfm_Evt*) osa_malloc(sizeof(UnifiMgtSetValueCfm_Evt));\
    evt->status = p1_status;\
    evt->appValueId = p2_appValueId;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_SET_VALUE_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_GET_VALUE.request -------------------------- */
typedef struct UnifiMgtGetValueReq_Evt
{
    FsmEvent common;
    unifi_AppValueId appValueId;
} UnifiMgtGetValueReq_Evt;

#define send_unifi_mgt_get_value_req(context, pid, p1_appValueId) \
{ \
    UnifiMgtGetValueReq_Evt *evt = (UnifiMgtGetValueReq_Evt*) osa_malloc(sizeof(UnifiMgtGetValueReq_Evt));\
    evt->appValueId = p1_appValueId;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_GET_VALUE_REQ_ID);\
}

#define send_unifi_mgt_get_value_req_external(context, pid, p1_appValueId) \
{ \
    UnifiMgtGetValueReq_Evt *evt = (UnifiMgtGetValueReq_Evt*) osa_malloc(sizeof(UnifiMgtGetValueReq_Evt));\
    evt->appValueId = p1_appValueId;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_GET_VALUE_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_GET_VALUE.confirm -------------------------- */
typedef struct UnifiMgtGetValueCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_AppValue appValue;
} UnifiMgtGetValueCfm_Evt;

#define send_unifi_mgt_get_value_cfm(context, pid, p1_status, p2_appValue) \
{ \
    UnifiMgtGetValueCfm_Evt *evt = (UnifiMgtGetValueCfm_Evt*) osa_malloc(sizeof(UnifiMgtGetValueCfm_Evt));\
    evt->status = p1_status;\
    evt->appValue = p2_appValue;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_GET_VALUE_CFM_ID);\
}

#define send_unifi_mgt_get_value_cfm_external(context, pid, p1_status, p2_appValue) \
{ \
    UnifiMgtGetValueCfm_Evt *evt = (UnifiMgtGetValueCfm_Evt*) osa_malloc(sizeof(UnifiMgtGetValueCfm_Evt));\
    evt->status = p1_status;\
    evt->appValue = p2_appValue;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_GET_VALUE_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_MIB_SET.request -------------------------- */
typedef struct UnifiMgtMibSetReq_Evt
{
    FsmEvent common;
    unifi_DataBlock mibAttribute;
} UnifiMgtMibSetReq_Evt;

#define send_unifi_mgt_mib_set_req(context, pid, p1_mibAttribute) \
{ \
    UnifiMgtMibSetReq_Evt *evt = (UnifiMgtMibSetReq_Evt*) osa_malloc(sizeof(UnifiMgtMibSetReq_Evt));\
    evt->mibAttribute = p1_mibAttribute;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_SET_REQ_ID);\
}

#define send_unifi_mgt_mib_set_req_external(context, pid, p1_mibAttribute) \
{ \
    UnifiMgtMibSetReq_Evt *evt = (UnifiMgtMibSetReq_Evt*) osa_malloc(sizeof(UnifiMgtMibSetReq_Evt));\
    evt->mibAttribute = p1_mibAttribute;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_SET_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_MIB_SET.confirm -------------------------- */
typedef struct UnifiMgtMibSetCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiMgtMibSetCfm_Evt;

#define send_unifi_mgt_mib_set_cfm(context, pid, p1_status) \
{ \
    UnifiMgtMibSetCfm_Evt *evt = (UnifiMgtMibSetCfm_Evt*) osa_malloc(sizeof(UnifiMgtMibSetCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_SET_CFM_ID);\
}

#define send_unifi_mgt_mib_set_cfm_external(context, pid, p1_status) \
{ \
    UnifiMgtMibSetCfm_Evt *evt = (UnifiMgtMibSetCfm_Evt*) osa_malloc(sizeof(UnifiMgtMibSetCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_SET_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_MIB_GET.request -------------------------- */
typedef struct UnifiMgtMibGetReq_Evt
{
    FsmEvent common;
    unifi_DataBlock mibAttribute;
} UnifiMgtMibGetReq_Evt;

#define send_unifi_mgt_mib_get_req(context, pid, p1_mibAttribute) \
{ \
    UnifiMgtMibGetReq_Evt *evt = (UnifiMgtMibGetReq_Evt*) osa_malloc(sizeof(UnifiMgtMibGetReq_Evt));\
    evt->mibAttribute = p1_mibAttribute;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_GET_REQ_ID);\
}

#define send_unifi_mgt_mib_get_req_external(context, pid, p1_mibAttribute) \
{ \
    UnifiMgtMibGetReq_Evt *evt = (UnifiMgtMibGetReq_Evt*) osa_malloc(sizeof(UnifiMgtMibGetReq_Evt));\
    evt->mibAttribute = p1_mibAttribute;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_GET_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_MIB_GET.confirm -------------------------- */
typedef struct UnifiMgtMibGetCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_DataBlock mibAttributeValue;
} UnifiMgtMibGetCfm_Evt;

#define send_unifi_mgt_mib_get_cfm(context, pid, p1_status, p2_mibAttributeValue) \
{ \
    UnifiMgtMibGetCfm_Evt *evt = (UnifiMgtMibGetCfm_Evt*) osa_malloc(sizeof(UnifiMgtMibGetCfm_Evt));\
    evt->status = p1_status;\
    evt->mibAttributeValue = p2_mibAttributeValue;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_GET_CFM_ID);\
}

#define send_unifi_mgt_mib_get_cfm_external(context, pid, p1_status, p2_mibAttributeValue) \
{ \
    UnifiMgtMibGetCfm_Evt *evt = (UnifiMgtMibGetCfm_Evt*) osa_malloc(sizeof(UnifiMgtMibGetCfm_Evt));\
    evt->status = p1_status;\
    evt->mibAttributeValue = p2_mibAttributeValue;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_GET_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_MIB_GET_NEXT.request -------------------------- */
typedef struct UnifiMgtMibGetNextReq_Evt
{
    FsmEvent common;
    unifi_DataBlock mibAttribute;
} UnifiMgtMibGetNextReq_Evt;

#define send_unifi_mgt_mib_get_next_req(context, pid, p1_mibAttribute) \
{ \
    UnifiMgtMibGetNextReq_Evt *evt = (UnifiMgtMibGetNextReq_Evt*) osa_malloc(sizeof(UnifiMgtMibGetNextReq_Evt));\
    evt->mibAttribute = p1_mibAttribute;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_GET_NEXT_REQ_ID);\
}

#define send_unifi_mgt_mib_get_next_req_external(context, pid, p1_mibAttribute) \
{ \
    UnifiMgtMibGetNextReq_Evt *evt = (UnifiMgtMibGetNextReq_Evt*) osa_malloc(sizeof(UnifiMgtMibGetNextReq_Evt));\
    evt->mibAttribute = p1_mibAttribute;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_GET_NEXT_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_MIB_GET_NEXT.confirm -------------------------- */
typedef struct UnifiMgtMibGetNextCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_DataBlock mibAttribute;
} UnifiMgtMibGetNextCfm_Evt;

#define send_unifi_mgt_mib_get_next_cfm(context, pid, p1_status, p2_mibAttribute) \
{ \
    UnifiMgtMibGetNextCfm_Evt *evt = (UnifiMgtMibGetNextCfm_Evt*) osa_malloc(sizeof(UnifiMgtMibGetNextCfm_Evt));\
    evt->status = p1_status;\
    evt->mibAttribute = p2_mibAttribute;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_GET_NEXT_CFM_ID);\
}

#define send_unifi_mgt_mib_get_next_cfm_external(context, pid, p1_status, p2_mibAttribute) \
{ \
    UnifiMgtMibGetNextCfm_Evt *evt = (UnifiMgtMibGetNextCfm_Evt*) osa_malloc(sizeof(UnifiMgtMibGetNextCfm_Evt));\
    evt->status = p1_status;\
    evt->mibAttribute = p2_mibAttribute;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIB_GET_NEXT_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_SCAN_FULL.request -------------------------- */
typedef struct UnifiMgtScanFullReq_Evt
{
    FsmEvent common;
    unifi_SSID ssid;
    Boolean forceScan;
    unifi_ScanType scanType;
    unifi_DataBlock channelList;
} UnifiMgtScanFullReq_Evt;

#define send_unifi_mgt_scan_full_req(context, pid, p1_ssid, p2_forceScan, p3_scanType, p4_channelList) \
{ \
    UnifiMgtScanFullReq_Evt *evt = (UnifiMgtScanFullReq_Evt*) osa_malloc(sizeof(UnifiMgtScanFullReq_Evt));\
    evt->ssid = p1_ssid;\
    evt->forceScan = p2_forceScan;\
    evt->scanType = p3_scanType;\
    evt->channelList = p4_channelList;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_SCAN_FULL_REQ_ID);\
}

#define send_unifi_mgt_scan_full_req_external(context, pid, p1_ssid, p2_forceScan, p3_scanType, p4_channelList) \
{ \
    UnifiMgtScanFullReq_Evt *evt = (UnifiMgtScanFullReq_Evt*) osa_malloc(sizeof(UnifiMgtScanFullReq_Evt));\
    evt->ssid = p1_ssid;\
    evt->forceScan = p2_forceScan;\
    evt->scanType = p3_scanType;\
    evt->channelList = p4_channelList;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_SCAN_FULL_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_SCAN_FULL.confirm -------------------------- */
typedef struct UnifiMgtScanFullCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiMgtScanFullCfm_Evt;

#define send_unifi_mgt_scan_full_cfm(context, pid, p1_status) \
{ \
    UnifiMgtScanFullCfm_Evt *evt = (UnifiMgtScanFullCfm_Evt*) osa_malloc(sizeof(UnifiMgtScanFullCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_SCAN_FULL_CFM_ID);\
}

#define send_unifi_mgt_scan_full_cfm_external(context, pid, p1_status) \
{ \
    UnifiMgtScanFullCfm_Evt *evt = (UnifiMgtScanFullCfm_Evt*) osa_malloc(sizeof(UnifiMgtScanFullCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_SCAN_FULL_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_SCAN_RESULTS_GET.request -------------------------- */
typedef struct UnifiMgtScanResultsGetReq_Evt
{
    FsmEvent common;
} UnifiMgtScanResultsGetReq_Evt;

#define send_unifi_mgt_scan_results_get_req(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_MGT_SCAN_RESULTS_GET_REQ_ID);\
}

#define send_unifi_mgt_scan_results_get_req_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_MGT_SCAN_RESULTS_GET_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_SCAN_RESULTS_GET.confirm -------------------------- */
typedef struct UnifiMgtScanResultsGetCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_ScanResultList resultsBuffer;
} UnifiMgtScanResultsGetCfm_Evt;

#define send_unifi_mgt_scan_results_get_cfm(context, pid, p1_status, p2_resultsBuffer) \
{ \
    UnifiMgtScanResultsGetCfm_Evt *evt = (UnifiMgtScanResultsGetCfm_Evt*) osa_malloc(sizeof(UnifiMgtScanResultsGetCfm_Evt));\
    evt->status = p1_status;\
    evt->resultsBuffer = p2_resultsBuffer;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_SCAN_RESULTS_GET_CFM_ID);\
}

#define send_unifi_mgt_scan_results_get_cfm_external(context, pid, p1_status, p2_resultsBuffer) \
{ \
    UnifiMgtScanResultsGetCfm_Evt *evt = (UnifiMgtScanResultsGetCfm_Evt*) osa_malloc(sizeof(UnifiMgtScanResultsGetCfm_Evt));\
    evt->status = p1_status;\
    evt->resultsBuffer = p2_resultsBuffer;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_SCAN_RESULTS_GET_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_SCAN_RESULT.indication -------------------------- */
typedef struct UnifiMgtScanResultInd_Evt
{
    FsmEvent common;
    unifi_ScanResult result;
} UnifiMgtScanResultInd_Evt;

#define send_unifi_mgt_scan_result_ind(context, pid, p1_result) \
{ \
    UnifiMgtScanResultInd_Evt *evt = (UnifiMgtScanResultInd_Evt*) osa_malloc(sizeof(UnifiMgtScanResultInd_Evt));\
    evt->result = p1_result;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_SCAN_RESULT_IND_ID);\
}

#define send_unifi_mgt_scan_result_ind_external(context, pid, p1_result) \
{ \
    UnifiMgtScanResultInd_Evt *evt = (UnifiMgtScanResultInd_Evt*) osa_malloc(sizeof(UnifiMgtScanResultInd_Evt));\
    evt->result = p1_result;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_SCAN_RESULT_IND_ID);\
}

/* -------------------------- UNIFI_MGT_CONNECT.request -------------------------- */
typedef struct UnifiMgtConnectReq_Evt
{
    FsmEvent common;
    unifi_ConnectionConfig connectionConfig;
} UnifiMgtConnectReq_Evt;

#define send_unifi_mgt_connect_req(context, pid, p1_connectionConfig) \
{ \
    UnifiMgtConnectReq_Evt *evt = (UnifiMgtConnectReq_Evt*) osa_malloc(sizeof(UnifiMgtConnectReq_Evt));\
    evt->connectionConfig = p1_connectionConfig;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_CONNECT_REQ_ID);\
}

#define send_unifi_mgt_connect_req_external(context, pid, p1_connectionConfig) \
{ \
    UnifiMgtConnectReq_Evt *evt = (UnifiMgtConnectReq_Evt*) osa_malloc(sizeof(UnifiMgtConnectReq_Evt));\
    evt->connectionConfig = p1_connectionConfig;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_CONNECT_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_CONNECT.confirm -------------------------- */
typedef struct UnifiMgtConnectCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiMgtConnectCfm_Evt;

#define send_unifi_mgt_connect_cfm(context, pid, p1_status) \
{ \
    UnifiMgtConnectCfm_Evt *evt = (UnifiMgtConnectCfm_Evt*) osa_malloc(sizeof(UnifiMgtConnectCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_CONNECT_CFM_ID);\
}

#define send_unifi_mgt_connect_cfm_external(context, pid, p1_status) \
{ \
    UnifiMgtConnectCfm_Evt *evt = (UnifiMgtConnectCfm_Evt*) osa_malloc(sizeof(UnifiMgtConnectCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_CONNECT_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_MEDIA_STATUS.indication -------------------------- */
typedef struct UnifiMgtMediaStatusInd_Evt
{
    FsmEvent common;
    unifi_MediaStatus mediaStatus;
    unifi_ConnectionInfo connectionInfo;
} UnifiMgtMediaStatusInd_Evt;

#define send_unifi_mgt_media_status_ind(context, pid, p1_mediaStatus, p2_connectionInfo) \
{ \
    UnifiMgtMediaStatusInd_Evt *evt = (UnifiMgtMediaStatusInd_Evt*) osa_malloc(sizeof(UnifiMgtMediaStatusInd_Evt));\
    evt->mediaStatus = p1_mediaStatus;\
    evt->connectionInfo = p2_connectionInfo;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MEDIA_STATUS_IND_ID);\
}

#define send_unifi_mgt_media_status_ind_external(context, pid, p1_mediaStatus, p2_connectionInfo) \
{ \
    UnifiMgtMediaStatusInd_Evt *evt = (UnifiMgtMediaStatusInd_Evt*) osa_malloc(sizeof(UnifiMgtMediaStatusInd_Evt));\
    evt->mediaStatus = p1_mediaStatus;\
    evt->connectionInfo = p2_connectionInfo;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MEDIA_STATUS_IND_ID);\
}

/* -------------------------- UNIFI_MGT_CONNECTION_QUALITY.indication -------------------------- */
typedef struct UnifiMgtConnectionQualityInd_Evt
{
    FsmEvent common;
    unifi_ConnectionStats connectionStats;
} UnifiMgtConnectionQualityInd_Evt;

#define send_unifi_mgt_connection_quality_ind(context, pid, p1_connectionStats) \
{ \
    UnifiMgtConnectionQualityInd_Evt *evt = (UnifiMgtConnectionQualityInd_Evt*) osa_malloc(sizeof(UnifiMgtConnectionQualityInd_Evt));\
    evt->connectionStats = p1_connectionStats;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_CONNECTION_QUALITY_IND_ID);\
}

#define send_unifi_mgt_connection_quality_ind_external(context, pid, p1_connectionStats) \
{ \
    UnifiMgtConnectionQualityInd_Evt *evt = (UnifiMgtConnectionQualityInd_Evt*) osa_malloc(sizeof(UnifiMgtConnectionQualityInd_Evt));\
    evt->connectionStats = p1_connectionStats;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_CONNECTION_QUALITY_IND_ID);\
}

/* -------------------------- UNIFI_MGT_DISCONNECT.request -------------------------- */
typedef struct UnifiMgtDisconnectReq_Evt
{
    FsmEvent common;
} UnifiMgtDisconnectReq_Evt;

#define send_unifi_mgt_disconnect_req(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_MGT_DISCONNECT_REQ_ID);\
}

#define send_unifi_mgt_disconnect_req_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_MGT_DISCONNECT_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_DISCONNECT.confirm -------------------------- */
typedef struct UnifiMgtDisconnectCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiMgtDisconnectCfm_Evt;

#define send_unifi_mgt_disconnect_cfm(context, pid, p1_status) \
{ \
    UnifiMgtDisconnectCfm_Evt *evt = (UnifiMgtDisconnectCfm_Evt*) osa_malloc(sizeof(UnifiMgtDisconnectCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_DISCONNECT_CFM_ID);\
}

#define send_unifi_mgt_disconnect_cfm_external(context, pid, p1_status) \
{ \
    UnifiMgtDisconnectCfm_Evt *evt = (UnifiMgtDisconnectCfm_Evt*) osa_malloc(sizeof(UnifiMgtDisconnectCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_DISCONNECT_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_MULTICAST_ADDRESS.request -------------------------- */
typedef struct UnifiMgtMulticastAddressReq_Evt
{
    FsmEvent common;
    unifi_ListAction action;
    unifi_MulticastAddressList setAddresses;
} UnifiMgtMulticastAddressReq_Evt;

#define send_unifi_mgt_multicast_address_req(context, pid, p1_action, p2_setAddresses) \
{ \
    UnifiMgtMulticastAddressReq_Evt *evt = (UnifiMgtMulticastAddressReq_Evt*) osa_malloc(sizeof(UnifiMgtMulticastAddressReq_Evt));\
    evt->action = p1_action;\
    evt->setAddresses = p2_setAddresses;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MULTICAST_ADDRESS_REQ_ID);\
}

#define send_unifi_mgt_multicast_address_req_external(context, pid, p1_action, p2_setAddresses) \
{ \
    UnifiMgtMulticastAddressReq_Evt *evt = (UnifiMgtMulticastAddressReq_Evt*) osa_malloc(sizeof(UnifiMgtMulticastAddressReq_Evt));\
    evt->action = p1_action;\
    evt->setAddresses = p2_setAddresses;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MULTICAST_ADDRESS_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_MULTICAST_ADDRESS.confirm -------------------------- */
typedef struct UnifiMgtMulticastAddressCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_ListAction action;
    unifi_MulticastAddressList getAddresses;
} UnifiMgtMulticastAddressCfm_Evt;

#define send_unifi_mgt_multicast_address_cfm(context, pid, p1_status, p2_action, p3_getAddresses) \
{ \
    UnifiMgtMulticastAddressCfm_Evt *evt = (UnifiMgtMulticastAddressCfm_Evt*) osa_malloc(sizeof(UnifiMgtMulticastAddressCfm_Evt));\
    evt->status = p1_status;\
    evt->action = p2_action;\
    evt->getAddresses = p3_getAddresses;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MULTICAST_ADDRESS_CFM_ID);\
}

#define send_unifi_mgt_multicast_address_cfm_external(context, pid, p1_status, p2_action, p3_getAddresses) \
{ \
    UnifiMgtMulticastAddressCfm_Evt *evt = (UnifiMgtMulticastAddressCfm_Evt*) osa_malloc(sizeof(UnifiMgtMulticastAddressCfm_Evt));\
    evt->status = p1_status;\
    evt->action = p2_action;\
    evt->getAddresses = p3_getAddresses;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MULTICAST_ADDRESS_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_MIC_FAILURE.indication -------------------------- */
typedef struct UnifiMgtMicFailureInd_Evt
{
    FsmEvent common;
    Boolean secondFailure;
    uint16 count;
    unifi_MACAddress address;
    unifi_KeyType keyType;
    uint16 keyId;
    unifi_SequenceCount tSC;
} UnifiMgtMicFailureInd_Evt;

#define send_unifi_mgt_mic_failure_ind(context, pid, p1_secondFailure, p2_count, p3_address, p4_keyType, p5_keyId, p6_tSC) \
{ \
    UnifiMgtMicFailureInd_Evt *evt = (UnifiMgtMicFailureInd_Evt*) osa_malloc(sizeof(UnifiMgtMicFailureInd_Evt));\
    evt->secondFailure = p1_secondFailure;\
    evt->count = p2_count;\
    evt->address = p3_address;\
    evt->keyType = p4_keyType;\
    evt->keyId = p5_keyId;\
    evt->tSC = p6_tSC;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIC_FAILURE_IND_ID);\
}

#define send_unifi_mgt_mic_failure_ind_external(context, pid, p1_secondFailure, p2_count, p3_address, p4_keyType, p5_keyId, p6_tSC) \
{ \
    UnifiMgtMicFailureInd_Evt *evt = (UnifiMgtMicFailureInd_Evt*) osa_malloc(sizeof(UnifiMgtMicFailureInd_Evt));\
    evt->secondFailure = p1_secondFailure;\
    evt->count = p2_count;\
    evt->address = p3_address;\
    evt->keyType = p4_keyType;\
    evt->keyId = p5_keyId;\
    evt->tSC = p6_tSC;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_MIC_FAILURE_IND_ID);\
}

/* -------------------------- UNIFI_MGT_PMKID_CANDIDATE_LIST.indication -------------------------- */
typedef struct UnifiMgtPmkidCandidateListInd_Evt
{
    FsmEvent common;
    unifi_PmkidCandidateList candidates;
} UnifiMgtPmkidCandidateListInd_Evt;

#define send_unifi_mgt_pmkid_candidate_list_ind(context, pid, p1_candidates) \
{ \
    UnifiMgtPmkidCandidateListInd_Evt *evt = (UnifiMgtPmkidCandidateListInd_Evt*) osa_malloc(sizeof(UnifiMgtPmkidCandidateListInd_Evt));\
    evt->candidates = p1_candidates;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_PMKID_CANDIDATE_LIST_IND_ID);\
}

#define send_unifi_mgt_pmkid_candidate_list_ind_external(context, pid, p1_candidates) \
{ \
    UnifiMgtPmkidCandidateListInd_Evt *evt = (UnifiMgtPmkidCandidateListInd_Evt*) osa_malloc(sizeof(UnifiMgtPmkidCandidateListInd_Evt));\
    evt->candidates = p1_candidates;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_PMKID_CANDIDATE_LIST_IND_ID);\
}

/* -------------------------- UNIFI_MGT_PMKID.request -------------------------- */
typedef struct UnifiMgtPmkidReq_Evt
{
    FsmEvent common;
    unifi_ListAction action;
    unifi_PmkidList setPmkidList;
} UnifiMgtPmkidReq_Evt;

#define send_unifi_mgt_pmkid_req(context, pid, p1_action, p2_setPmkidList) \
{ \
    UnifiMgtPmkidReq_Evt *evt = (UnifiMgtPmkidReq_Evt*) osa_malloc(sizeof(UnifiMgtPmkidReq_Evt));\
    evt->action = p1_action;\
    evt->setPmkidList = p2_setPmkidList;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_PMKID_REQ_ID);\
}

#define send_unifi_mgt_pmkid_req_external(context, pid, p1_action, p2_setPmkidList) \
{ \
    UnifiMgtPmkidReq_Evt *evt = (UnifiMgtPmkidReq_Evt*) osa_malloc(sizeof(UnifiMgtPmkidReq_Evt));\
    evt->action = p1_action;\
    evt->setPmkidList = p2_setPmkidList;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_PMKID_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_PMKID.confirm -------------------------- */
typedef struct UnifiMgtPmkidCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_ListAction action;
    unifi_PmkidList getPmkidList;
} UnifiMgtPmkidCfm_Evt;

#define send_unifi_mgt_pmkid_cfm(context, pid, p1_status, p2_action, p3_getPmkidList) \
{ \
    UnifiMgtPmkidCfm_Evt *evt = (UnifiMgtPmkidCfm_Evt*) osa_malloc(sizeof(UnifiMgtPmkidCfm_Evt));\
    evt->status = p1_status;\
    evt->action = p2_action;\
    evt->getPmkidList = p3_getPmkidList;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_PMKID_CFM_ID);\
}

#define send_unifi_mgt_pmkid_cfm_external(context, pid, p1_status, p2_action, p3_getPmkidList) \
{ \
    UnifiMgtPmkidCfm_Evt *evt = (UnifiMgtPmkidCfm_Evt*) osa_malloc(sizeof(UnifiMgtPmkidCfm_Evt));\
    evt->status = p1_status;\
    evt->action = p2_action;\
    evt->getPmkidList = p3_getPmkidList;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_PMKID_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_KEY.request -------------------------- */
typedef struct UnifiMgtKeyReq_Evt
{
    FsmEvent common;
    unifi_ListAction action;
    unifi_Key key;
} UnifiMgtKeyReq_Evt;

#define send_unifi_mgt_key_req(context, pid, p1_action, p2_key) \
{ \
    UnifiMgtKeyReq_Evt *evt = (UnifiMgtKeyReq_Evt*) osa_malloc(sizeof(UnifiMgtKeyReq_Evt));\
    evt->action = p1_action;\
    evt->key = p2_key;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_KEY_REQ_ID);\
}

#define send_unifi_mgt_key_req_external(context, pid, p1_action, p2_key) \
{ \
    UnifiMgtKeyReq_Evt *evt = (UnifiMgtKeyReq_Evt*) osa_malloc(sizeof(UnifiMgtKeyReq_Evt));\
    evt->action = p1_action;\
    evt->key = p2_key;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_KEY_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_KEY.confirm -------------------------- */
typedef struct UnifiMgtKeyCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_ListAction action;
} UnifiMgtKeyCfm_Evt;

#define send_unifi_mgt_key_cfm(context, pid, p1_status, p2_action) \
{ \
    UnifiMgtKeyCfm_Evt *evt = (UnifiMgtKeyCfm_Evt*) osa_malloc(sizeof(UnifiMgtKeyCfm_Evt));\
    evt->status = p1_status;\
    evt->action = p2_action;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_KEY_CFM_ID);\
}

#define send_unifi_mgt_key_cfm_external(context, pid, p1_status, p2_action) \
{ \
    UnifiMgtKeyCfm_Evt *evt = (UnifiMgtKeyCfm_Evt*) osa_malloc(sizeof(UnifiMgtKeyCfm_Evt));\
    evt->status = p1_status;\
    evt->action = p2_action;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_KEY_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_PACKET_FILTER_SET.request -------------------------- */
typedef struct UnifiMgtPacketFilterSetReq_Evt
{
    FsmEvent common;
    unifi_DataBlock filter;
    unifi_PacketFilterMode mode;
    unifi_IPV4Address arpFilterAddress;
} UnifiMgtPacketFilterSetReq_Evt;

#define send_unifi_mgt_packet_filter_set_req(context, pid, p1_filter, p2_mode, p3_arpFilterAddress) \
{ \
    UnifiMgtPacketFilterSetReq_Evt *evt = (UnifiMgtPacketFilterSetReq_Evt*) osa_malloc(sizeof(UnifiMgtPacketFilterSetReq_Evt));\
    evt->filter = p1_filter;\
    evt->mode = p2_mode;\
    evt->arpFilterAddress = p3_arpFilterAddress;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_PACKET_FILTER_SET_REQ_ID);\
}

#define send_unifi_mgt_packet_filter_set_req_external(context, pid, p1_filter, p2_mode, p3_arpFilterAddress) \
{ \
    UnifiMgtPacketFilterSetReq_Evt *evt = (UnifiMgtPacketFilterSetReq_Evt*) osa_malloc(sizeof(UnifiMgtPacketFilterSetReq_Evt));\
    evt->filter = p1_filter;\
    evt->mode = p2_mode;\
    evt->arpFilterAddress = p3_arpFilterAddress;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_PACKET_FILTER_SET_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_PACKET_FILTER_SET.confirm -------------------------- */
typedef struct UnifiMgtPacketFilterSetCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiMgtPacketFilterSetCfm_Evt;

#define send_unifi_mgt_packet_filter_set_cfm(context, pid, p1_status) \
{ \
    UnifiMgtPacketFilterSetCfm_Evt *evt = (UnifiMgtPacketFilterSetCfm_Evt*) osa_malloc(sizeof(UnifiMgtPacketFilterSetCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_PACKET_FILTER_SET_CFM_ID);\
}

#define send_unifi_mgt_packet_filter_set_cfm_external(context, pid, p1_status) \
{ \
    UnifiMgtPacketFilterSetCfm_Evt *evt = (UnifiMgtPacketFilterSetCfm_Evt*) osa_malloc(sizeof(UnifiMgtPacketFilterSetCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_PACKET_FILTER_SET_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_TSPEC.request -------------------------- */
typedef struct UnifiMgtTspecReq_Evt
{
    FsmEvent common;
    unifi_ListAction action;
    uint32 transactionId;
    Boolean strict;
    unifi_DataBlock tspec;
    unifi_DataBlock tclas;
} UnifiMgtTspecReq_Evt;

#define send_unifi_mgt_tspec_req(context, pid, p1_action, p2_transactionId, p3_strict, p4_tspec, p5_tclas) \
{ \
    UnifiMgtTspecReq_Evt *evt = (UnifiMgtTspecReq_Evt*) osa_malloc(sizeof(UnifiMgtTspecReq_Evt));\
    evt->action = p1_action;\
    evt->transactionId = p2_transactionId;\
    evt->strict = p3_strict;\
    evt->tspec = p4_tspec;\
    evt->tclas = p5_tclas;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_TSPEC_REQ_ID);\
}

#define send_unifi_mgt_tspec_req_external(context, pid, p1_action, p2_transactionId, p3_strict, p4_tspec, p5_tclas) \
{ \
    UnifiMgtTspecReq_Evt *evt = (UnifiMgtTspecReq_Evt*) osa_malloc(sizeof(UnifiMgtTspecReq_Evt));\
    evt->action = p1_action;\
    evt->transactionId = p2_transactionId;\
    evt->strict = p3_strict;\
    evt->tspec = p4_tspec;\
    evt->tclas = p5_tclas;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_TSPEC_REQ_ID);\
}

/* -------------------------- UNIFI_MGT_TSPEC.confirm -------------------------- */
typedef struct UnifiMgtTspecCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    uint32 transactionId;
    unifi_TspecResultCode tspecResultCode;
    unifi_DataBlock tspec;
} UnifiMgtTspecCfm_Evt;

#define send_unifi_mgt_tspec_cfm(context, pid, p1_status, p2_transactionId, p3_tspecResultCode, p4_tspec) \
{ \
    UnifiMgtTspecCfm_Evt *evt = (UnifiMgtTspecCfm_Evt*) osa_malloc(sizeof(UnifiMgtTspecCfm_Evt));\
    evt->status = p1_status;\
    evt->transactionId = p2_transactionId;\
    evt->tspecResultCode = p3_tspecResultCode;\
    evt->tspec = p4_tspec;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_TSPEC_CFM_ID);\
}

#define send_unifi_mgt_tspec_cfm_external(context, pid, p1_status, p2_transactionId, p3_tspecResultCode, p4_tspec) \
{ \
    UnifiMgtTspecCfm_Evt *evt = (UnifiMgtTspecCfm_Evt*) osa_malloc(sizeof(UnifiMgtTspecCfm_Evt));\
    evt->status = p1_status;\
    evt->transactionId = p2_transactionId;\
    evt->tspecResultCode = p3_tspecResultCode;\
    evt->tspec = p4_tspec;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_TSPEC_CFM_ID);\
}

/* -------------------------- UNIFI_MGT_TSPEC.indication -------------------------- */
typedef struct UnifiMgtTspecInd_Evt
{
    FsmEvent common;
    unifi_ListAction action;
    uint32 transactionId;
} UnifiMgtTspecInd_Evt;

#define send_unifi_mgt_tspec_ind(context, pid, p1_action, p2_transactionId) \
{ \
    UnifiMgtTspecInd_Evt *evt = (UnifiMgtTspecInd_Evt*) osa_malloc(sizeof(UnifiMgtTspecInd_Evt));\
    evt->action = p1_action;\
    evt->transactionId = p2_transactionId;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_MGT_TSPEC_IND_ID);\
}

#define send_unifi_mgt_tspec_ind_external(context, pid, p1_action, p2_transactionId) \
{ \
    UnifiMgtTspecInd_Evt *evt = (UnifiMgtTspecInd_Evt*) osa_malloc(sizeof(UnifiMgtTspecInd_Evt));\
    evt->action = p1_action;\
    evt->transactionId = p2_transactionId;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_MGT_TSPEC_IND_ID);\
}

/* -------------------------- UNIFI_SYS_WIFI_ON.request -------------------------- */
typedef struct UnifiSysWifiOnReq_Evt
{
    FsmEvent common;
} UnifiSysWifiOnReq_Evt;

#define send_unifi_sys_wifi_on_req(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_SYS_WIFI_ON_REQ_ID);\
}

#define send_unifi_sys_wifi_on_req_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_SYS_WIFI_ON_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_WIFI_ON.indication -------------------------- */
typedef struct UnifiSysWifiOnInd_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_Versions versions;
} UnifiSysWifiOnInd_Evt;

#define send_unifi_sys_wifi_on_ind(context, pid, p1_status, p2_versions) \
{ \
    UnifiSysWifiOnInd_Evt *evt = (UnifiSysWifiOnInd_Evt*) osa_malloc(sizeof(UnifiSysWifiOnInd_Evt));\
    evt->status = p1_status;\
    evt->versions = p2_versions;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_WIFI_ON_IND_ID);\
}

#define send_unifi_sys_wifi_on_ind_external(context, pid, p1_status, p2_versions) \
{ \
    UnifiSysWifiOnInd_Evt *evt = (UnifiSysWifiOnInd_Evt*) osa_malloc(sizeof(UnifiSysWifiOnInd_Evt));\
    evt->status = p1_status;\
    evt->versions = p2_versions;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_WIFI_ON_IND_ID);\
}

/* -------------------------- UNIFI_SYS_WIFI_ON.response -------------------------- */
typedef struct UnifiSysWifiOnRsp_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_MACAddress stationMacAddress;
} UnifiSysWifiOnRsp_Evt;

#define send_unifi_sys_wifi_on_rsp(context, pid, p1_status, p2_stationMacAddress) \
{ \
    UnifiSysWifiOnRsp_Evt *evt = (UnifiSysWifiOnRsp_Evt*) osa_malloc(sizeof(UnifiSysWifiOnRsp_Evt));\
    evt->status = p1_status;\
    evt->stationMacAddress = p2_stationMacAddress;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_WIFI_ON_RSP_ID);\
}

#define send_unifi_sys_wifi_on_rsp_external(context, pid, p1_status, p2_stationMacAddress) \
{ \
    UnifiSysWifiOnRsp_Evt *evt = (UnifiSysWifiOnRsp_Evt*) osa_malloc(sizeof(UnifiSysWifiOnRsp_Evt));\
    evt->status = p1_status;\
    evt->stationMacAddress = p2_stationMacAddress;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_WIFI_ON_RSP_ID);\
}

/* -------------------------- UNIFI_SYS_WIFI_ON.confirm -------------------------- */
typedef struct UnifiSysWifiOnCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiSysWifiOnCfm_Evt;

#define send_unifi_sys_wifi_on_cfm(context, pid, p1_status) \
{ \
    UnifiSysWifiOnCfm_Evt *evt = (UnifiSysWifiOnCfm_Evt*) osa_malloc(sizeof(UnifiSysWifiOnCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_WIFI_ON_CFM_ID);\
}

#define send_unifi_sys_wifi_on_cfm_external(context, pid, p1_status) \
{ \
    UnifiSysWifiOnCfm_Evt *evt = (UnifiSysWifiOnCfm_Evt*) osa_malloc(sizeof(UnifiSysWifiOnCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_WIFI_ON_CFM_ID);\
}

/* -------------------------- UNIFI_SYS_WIFI_OFF.request -------------------------- */
typedef struct UnifiSysWifiOffReq_Evt
{
    FsmEvent common;
} UnifiSysWifiOffReq_Evt;

#define send_unifi_sys_wifi_off_req(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_SYS_WIFI_OFF_REQ_ID);\
}

#define send_unifi_sys_wifi_off_req_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_SYS_WIFI_OFF_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_WIFI_OFF.indication -------------------------- */
typedef struct UnifiSysWifiOffInd_Evt
{
    FsmEvent common;
    unifi_ControlIndication controlIndication;
} UnifiSysWifiOffInd_Evt;

#define send_unifi_sys_wifi_off_ind(context, pid, p1_controlIndication) \
{ \
    UnifiSysWifiOffInd_Evt *evt = (UnifiSysWifiOffInd_Evt*) osa_malloc(sizeof(UnifiSysWifiOffInd_Evt));\
    evt->controlIndication = p1_controlIndication;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_WIFI_OFF_IND_ID);\
}

#define send_unifi_sys_wifi_off_ind_external(context, pid, p1_controlIndication) \
{ \
    UnifiSysWifiOffInd_Evt *evt = (UnifiSysWifiOffInd_Evt*) osa_malloc(sizeof(UnifiSysWifiOffInd_Evt));\
    evt->controlIndication = p1_controlIndication;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_WIFI_OFF_IND_ID);\
}

/* -------------------------- UNIFI_SYS_WIFI_OFF.response -------------------------- */
typedef struct UnifiSysWifiOffRsp_Evt
{
    FsmEvent common;
} UnifiSysWifiOffRsp_Evt;

#define send_unifi_sys_wifi_off_rsp(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_SYS_WIFI_OFF_RSP_ID);\
}

#define send_unifi_sys_wifi_off_rsp_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_SYS_WIFI_OFF_RSP_ID);\
}

/* -------------------------- UNIFI_SYS_WIFI_OFF.confirm -------------------------- */
typedef struct UnifiSysWifiOffCfm_Evt
{
    FsmEvent common;
} UnifiSysWifiOffCfm_Evt;

#define send_unifi_sys_wifi_off_cfm(context, pid) \
{ \
    fsm_send_event(context, NULL, pid, UNIFI_SYS_WIFI_OFF_CFM_ID);\
}

#define send_unifi_sys_wifi_off_cfm_external(context, pid) \
{ \
    fsm_send_event_external(context, NULL, pid, UNIFI_SYS_WIFI_OFF_CFM_ID);\
}

/* -------------------------- UNIFI_SYS_SUSPEND.indication -------------------------- */
typedef struct UnifiSysSuspendInd_Evt
{
    FsmEvent common;
    Boolean hardSuspend;
    Boolean d3Suspend;
} UnifiSysSuspendInd_Evt;

#define send_unifi_sys_suspend_ind(context, pid, p1_hardSuspend, p2_d3Suspend) \
{ \
    UnifiSysSuspendInd_Evt *evt = (UnifiSysSuspendInd_Evt*) osa_malloc(sizeof(UnifiSysSuspendInd_Evt));\
    evt->hardSuspend = p1_hardSuspend;\
    evt->d3Suspend = p2_d3Suspend;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_SUSPEND_IND_ID);\
}

#define send_unifi_sys_suspend_ind_external(context, pid, p1_hardSuspend, p2_d3Suspend) \
{ \
    UnifiSysSuspendInd_Evt *evt = (UnifiSysSuspendInd_Evt*) osa_malloc(sizeof(UnifiSysSuspendInd_Evt));\
    evt->hardSuspend = p1_hardSuspend;\
    evt->d3Suspend = p2_d3Suspend;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_SUSPEND_IND_ID);\
}

/* -------------------------- UNIFI_SYS_SUSPEND.response -------------------------- */
typedef struct UnifiSysSuspendRsp_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiSysSuspendRsp_Evt;

#define send_unifi_sys_suspend_rsp(context, pid, p1_status) \
{ \
    UnifiSysSuspendRsp_Evt *evt = (UnifiSysSuspendRsp_Evt*) osa_malloc(sizeof(UnifiSysSuspendRsp_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_SUSPEND_RSP_ID);\
}

#define send_unifi_sys_suspend_rsp_external(context, pid, p1_status) \
{ \
    UnifiSysSuspendRsp_Evt *evt = (UnifiSysSuspendRsp_Evt*) osa_malloc(sizeof(UnifiSysSuspendRsp_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_SUSPEND_RSP_ID);\
}

/* -------------------------- UNIFI_SYS_RESUME.indication -------------------------- */
typedef struct UnifiSysResumeInd_Evt
{
    FsmEvent common;
    Boolean resumePowerMaintained;
} UnifiSysResumeInd_Evt;

#define send_unifi_sys_resume_ind(context, pid, p1_resumePowerMaintained) \
{ \
    UnifiSysResumeInd_Evt *evt = (UnifiSysResumeInd_Evt*) osa_malloc(sizeof(UnifiSysResumeInd_Evt));\
    evt->resumePowerMaintained = p1_resumePowerMaintained;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_RESUME_IND_ID);\
}

#define send_unifi_sys_resume_ind_external(context, pid, p1_resumePowerMaintained) \
{ \
    UnifiSysResumeInd_Evt *evt = (UnifiSysResumeInd_Evt*) osa_malloc(sizeof(UnifiSysResumeInd_Evt));\
    evt->resumePowerMaintained = p1_resumePowerMaintained;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_RESUME_IND_ID);\
}

/* -------------------------- UNIFI_SYS_RESUME.response -------------------------- */
typedef struct UnifiSysResumeRsp_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiSysResumeRsp_Evt;

#define send_unifi_sys_resume_rsp(context, pid, p1_status) \
{ \
    UnifiSysResumeRsp_Evt *evt = (UnifiSysResumeRsp_Evt*) osa_malloc(sizeof(UnifiSysResumeRsp_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_RESUME_RSP_ID);\
}

#define send_unifi_sys_resume_rsp_external(context, pid, p1_status) \
{ \
    UnifiSysResumeRsp_Evt *evt = (UnifiSysResumeRsp_Evt*) osa_malloc(sizeof(UnifiSysResumeRsp_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_RESUME_RSP_ID);\
}

/* -------------------------- UNIFI_SYS_HIP.request -------------------------- */
typedef struct UnifiSysHipReq_Evt
{
    FsmEvent common;
    unifi_DataBlock mlmeCommand;
    unifi_DataBlock dataRef1;
    unifi_DataBlock dataRef2;
} UnifiSysHipReq_Evt;

#define send_unifi_sys_hip_req(context, pid, p1_mlmeCommand, p2_dataRef1, p3_dataRef2) \
{ \
    UnifiSysHipReq_Evt *evt = (UnifiSysHipReq_Evt*) osa_malloc(sizeof(UnifiSysHipReq_Evt));\
    evt->mlmeCommand = p1_mlmeCommand;\
    evt->dataRef1 = p2_dataRef1;\
    evt->dataRef2 = p3_dataRef2;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_HIP_REQ_ID);\
}

#define send_unifi_sys_hip_req_external(context, pid, p1_mlmeCommand, p2_dataRef1, p3_dataRef2) \
{ \
    UnifiSysHipReq_Evt *evt = (UnifiSysHipReq_Evt*) osa_malloc(sizeof(UnifiSysHipReq_Evt));\
    evt->mlmeCommand = p1_mlmeCommand;\
    evt->dataRef1 = p2_dataRef1;\
    evt->dataRef2 = p3_dataRef2;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_HIP_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_HIP.indication -------------------------- */
typedef struct UnifiSysHipInd_Evt
{
    FsmEvent common;
    unifi_DataBlock mlmeCommand;
    unifi_DataBlock dataRef1;
    unifi_DataBlock dataRef2;
} UnifiSysHipInd_Evt;

#define send_unifi_sys_hip_ind(context, pid, p1_mlmeCommand, p2_dataRef1, p3_dataRef2) \
{ \
    UnifiSysHipInd_Evt *evt = (UnifiSysHipInd_Evt*) osa_malloc(sizeof(UnifiSysHipInd_Evt));\
    evt->mlmeCommand = p1_mlmeCommand;\
    evt->dataRef1 = p2_dataRef1;\
    evt->dataRef2 = p3_dataRef2;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_HIP_IND_ID);\
}

#define send_unifi_sys_hip_ind_external(context, pid, p1_mlmeCommand, p2_dataRef1, p3_dataRef2) \
{ \
    UnifiSysHipInd_Evt *evt = (UnifiSysHipInd_Evt*) osa_malloc(sizeof(UnifiSysHipInd_Evt));\
    evt->mlmeCommand = p1_mlmeCommand;\
    evt->dataRef1 = p2_dataRef1;\
    evt->dataRef2 = p3_dataRef2;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_HIP_IND_ID);\
}

/* -------------------------- UNIFI_SYS_QOS_CONTROL.request -------------------------- */
typedef struct UnifiSysQosControlReq_Evt
{
    FsmEvent common;
    unifi_QoSControl control;
} UnifiSysQosControlReq_Evt;

#define send_unifi_sys_qos_control_req(context, pid, p1_control) \
{ \
    UnifiSysQosControlReq_Evt *evt = (UnifiSysQosControlReq_Evt*) osa_malloc(sizeof(UnifiSysQosControlReq_Evt));\
    evt->control = p1_control;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_QOS_CONTROL_REQ_ID);\
}

#define send_unifi_sys_qos_control_req_external(context, pid, p1_control) \
{ \
    UnifiSysQosControlReq_Evt *evt = (UnifiSysQosControlReq_Evt*) osa_malloc(sizeof(UnifiSysQosControlReq_Evt));\
    evt->control = p1_control;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_QOS_CONTROL_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_QOS_CONTROL.confirm -------------------------- */
typedef struct UnifiSysQosControlCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiSysQosControlCfm_Evt;

#define send_unifi_sys_qos_control_cfm(context, pid, p1_status) \
{ \
    UnifiSysQosControlCfm_Evt *evt = (UnifiSysQosControlCfm_Evt*) osa_malloc(sizeof(UnifiSysQosControlCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_QOS_CONTROL_CFM_ID);\
}

#define send_unifi_sys_qos_control_cfm_external(context, pid, p1_status) \
{ \
    UnifiSysQosControlCfm_Evt *evt = (UnifiSysQosControlCfm_Evt*) osa_malloc(sizeof(UnifiSysQosControlCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_QOS_CONTROL_CFM_ID);\
}

/* -------------------------- UNIFI_SYS_PORT_CONFIGURE.request -------------------------- */
typedef struct UnifiSysPortConfigureReq_Evt
{
    FsmEvent common;
    unifi_PortAction uncontrolledPortAction;
    unifi_PortAction controlledPortAction;
    unifi_MACAddress macAddress;
} UnifiSysPortConfigureReq_Evt;

#define send_unifi_sys_port_configure_req(context, pid, p1_uncontrolledPortAction, p2_controlledPortAction, p3_macAddress) \
{ \
    UnifiSysPortConfigureReq_Evt *evt = (UnifiSysPortConfigureReq_Evt*) osa_malloc(sizeof(UnifiSysPortConfigureReq_Evt));\
    evt->uncontrolledPortAction = p1_uncontrolledPortAction;\
    evt->controlledPortAction = p2_controlledPortAction;\
    evt->macAddress = p3_macAddress;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_PORT_CONFIGURE_REQ_ID);\
}

#define send_unifi_sys_port_configure_req_external(context, pid, p1_uncontrolledPortAction, p2_controlledPortAction, p3_macAddress) \
{ \
    UnifiSysPortConfigureReq_Evt *evt = (UnifiSysPortConfigureReq_Evt*) osa_malloc(sizeof(UnifiSysPortConfigureReq_Evt));\
    evt->uncontrolledPortAction = p1_uncontrolledPortAction;\
    evt->controlledPortAction = p2_controlledPortAction;\
    evt->macAddress = p3_macAddress;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_PORT_CONFIGURE_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_PORT_CONFIGURE.confirm -------------------------- */
typedef struct UnifiSysPortConfigureCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_MACAddress macAddress;
} UnifiSysPortConfigureCfm_Evt;

#define send_unifi_sys_port_configure_cfm(context, pid, p1_status, p2_macAddress) \
{ \
    UnifiSysPortConfigureCfm_Evt *evt = (UnifiSysPortConfigureCfm_Evt*) osa_malloc(sizeof(UnifiSysPortConfigureCfm_Evt));\
    evt->status = p1_status;\
    evt->macAddress = p2_macAddress;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_PORT_CONFIGURE_CFM_ID);\
}

#define send_unifi_sys_port_configure_cfm_external(context, pid, p1_status, p2_macAddress) \
{ \
    UnifiSysPortConfigureCfm_Evt *evt = (UnifiSysPortConfigureCfm_Evt*) osa_malloc(sizeof(UnifiSysPortConfigureCfm_Evt));\
    evt->status = p1_status;\
    evt->macAddress = p2_macAddress;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_PORT_CONFIGURE_CFM_ID);\
}

/* -------------------------- UNIFI_SYS_CONFIGURE_POWER_MODE.request -------------------------- */
typedef struct UnifiSysConfigurePowerModeReq_Evt
{
    FsmEvent common;
    unifi_LowPowerMode mode;
    Boolean wakeHost;
} UnifiSysConfigurePowerModeReq_Evt;

#define send_unifi_sys_configure_power_mode_req(context, pid, p1_mode, p2_wakeHost) \
{ \
    UnifiSysConfigurePowerModeReq_Evt *evt = (UnifiSysConfigurePowerModeReq_Evt*) osa_malloc(sizeof(UnifiSysConfigurePowerModeReq_Evt));\
    evt->mode = p1_mode;\
    evt->wakeHost = p2_wakeHost;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_CONFIGURE_POWER_MODE_REQ_ID);\
}

#define send_unifi_sys_configure_power_mode_req_external(context, pid, p1_mode, p2_wakeHost) \
{ \
    UnifiSysConfigurePowerModeReq_Evt *evt = (UnifiSysConfigurePowerModeReq_Evt*) osa_malloc(sizeof(UnifiSysConfigurePowerModeReq_Evt));\
    evt->mode = p1_mode;\
    evt->wakeHost = p2_wakeHost;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_CONFIGURE_POWER_MODE_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_TRAFFIC_CONFIG.request -------------------------- */
typedef struct UnifiSysTrafficConfigReq_Evt
{
    FsmEvent common;
    unifi_traffic_configtype type;
    unifi_traffic_config config;
} UnifiSysTrafficConfigReq_Evt;

#define send_unifi_sys_traffic_config_req(context, pid, p1_type, p2_config) \
{ \
    UnifiSysTrafficConfigReq_Evt *evt = (UnifiSysTrafficConfigReq_Evt*) osa_malloc(sizeof(UnifiSysTrafficConfigReq_Evt));\
    evt->type = p1_type;\
    evt->config = p2_config;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_TRAFFIC_CONFIG_REQ_ID);\
}

#define send_unifi_sys_traffic_config_req_external(context, pid, p1_type, p2_config) \
{ \
    UnifiSysTrafficConfigReq_Evt *evt = (UnifiSysTrafficConfigReq_Evt*) osa_malloc(sizeof(UnifiSysTrafficConfigReq_Evt));\
    evt->type = p1_type;\
    evt->config = p2_config;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_TRAFFIC_CONFIG_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_TRAFFIC_SAMPLE.indication -------------------------- */
typedef struct UnifiSysTrafficSampleInd_Evt
{
    FsmEvent common;
    unifi_traffic_stats stats;
} UnifiSysTrafficSampleInd_Evt;

#define send_unifi_sys_traffic_sample_ind(context, pid, p1_stats) \
{ \
    UnifiSysTrafficSampleInd_Evt *evt = (UnifiSysTrafficSampleInd_Evt*) osa_malloc(sizeof(UnifiSysTrafficSampleInd_Evt));\
    evt->stats = p1_stats;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_TRAFFIC_SAMPLE_IND_ID);\
}

#define send_unifi_sys_traffic_sample_ind_external(context, pid, p1_stats) \
{ \
    UnifiSysTrafficSampleInd_Evt *evt = (UnifiSysTrafficSampleInd_Evt*) osa_malloc(sizeof(UnifiSysTrafficSampleInd_Evt));\
    evt->stats = p1_stats;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_TRAFFIC_SAMPLE_IND_ID);\
}

/* -------------------------- UNIFI_SYS_TRAFFIC_PROTOCOL.indication -------------------------- */
typedef struct UnifiSysTrafficProtocolInd_Evt
{
    FsmEvent common;
    unifi_traffic_packettype packetType;
    unifi_protocol_direction direction;
    unifi_MACAddress srcAddress;
} UnifiSysTrafficProtocolInd_Evt;

#define send_unifi_sys_traffic_protocol_ind(context, pid, p1_packetType, p2_direction, p3_srcAddress) \
{ \
    UnifiSysTrafficProtocolInd_Evt *evt = (UnifiSysTrafficProtocolInd_Evt*) osa_malloc(sizeof(UnifiSysTrafficProtocolInd_Evt));\
    evt->packetType = p1_packetType;\
    evt->direction = p2_direction;\
    evt->srcAddress = p3_srcAddress;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_TRAFFIC_PROTOCOL_IND_ID);\
}

#define send_unifi_sys_traffic_protocol_ind_external(context, pid, p1_packetType, p2_direction, p3_srcAddress) \
{ \
    UnifiSysTrafficProtocolInd_Evt *evt = (UnifiSysTrafficProtocolInd_Evt*) osa_malloc(sizeof(UnifiSysTrafficProtocolInd_Evt));\
    evt->packetType = p1_packetType;\
    evt->direction = p2_direction;\
    evt->srcAddress = p3_srcAddress;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_TRAFFIC_PROTOCOL_IND_ID);\
}

/* -------------------------- UNIFI_SYS_IP_CONFIGURED.indication -------------------------- */
typedef struct UnifiSysIpConfiguredInd_Evt
{
    FsmEvent common;
    Boolean ipConfigured;
} UnifiSysIpConfiguredInd_Evt;

#define send_unifi_sys_ip_configured_ind(context, pid, p1_ipConfigured) \
{ \
    UnifiSysIpConfiguredInd_Evt *evt = (UnifiSysIpConfiguredInd_Evt*) osa_malloc(sizeof(UnifiSysIpConfiguredInd_Evt));\
    evt->ipConfigured = p1_ipConfigured;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_IP_CONFIGURED_IND_ID);\
}

#define send_unifi_sys_ip_configured_ind_external(context, pid, p1_ipConfigured) \
{ \
    UnifiSysIpConfiguredInd_Evt *evt = (UnifiSysIpConfiguredInd_Evt*) osa_malloc(sizeof(UnifiSysIpConfiguredInd_Evt));\
    evt->ipConfigured = p1_ipConfigured;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_IP_CONFIGURED_IND_ID);\
}

/* -------------------------- UNIFI_SYS_MEDIA_STATUS.request -------------------------- */
typedef struct UnifiSysMediaStatusReq_Evt
{
    FsmEvent common;
    unifi_MediaStatus mediaStatus;
} UnifiSysMediaStatusReq_Evt;

#define send_unifi_sys_media_status_req(context, pid, p1_mediaStatus) \
{ \
    UnifiSysMediaStatusReq_Evt *evt = (UnifiSysMediaStatusReq_Evt*) osa_malloc(sizeof(UnifiSysMediaStatusReq_Evt));\
    evt->mediaStatus = p1_mediaStatus;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_MEDIA_STATUS_REQ_ID);\
}

#define send_unifi_sys_media_status_req_external(context, pid, p1_mediaStatus) \
{ \
    UnifiSysMediaStatusReq_Evt *evt = (UnifiSysMediaStatusReq_Evt*) osa_malloc(sizeof(UnifiSysMediaStatusReq_Evt));\
    evt->mediaStatus = p1_mediaStatus;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_MEDIA_STATUS_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_MULTICAST_ADDRESS.indication -------------------------- */
typedef struct UnifiSysMulticastAddressInd_Evt
{
    FsmEvent common;
    unifi_ListAction action;
    unifi_MulticastAddressList setAddresses;
} UnifiSysMulticastAddressInd_Evt;

#define send_unifi_sys_multicast_address_ind(context, pid, p1_action, p2_setAddresses) \
{ \
    UnifiSysMulticastAddressInd_Evt *evt = (UnifiSysMulticastAddressInd_Evt*) osa_malloc(sizeof(UnifiSysMulticastAddressInd_Evt));\
    evt->action = p1_action;\
    evt->setAddresses = p2_setAddresses;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_MULTICAST_ADDRESS_IND_ID);\
}

#define send_unifi_sys_multicast_address_ind_external(context, pid, p1_action, p2_setAddresses) \
{ \
    UnifiSysMulticastAddressInd_Evt *evt = (UnifiSysMulticastAddressInd_Evt*) osa_malloc(sizeof(UnifiSysMulticastAddressInd_Evt));\
    evt->action = p1_action;\
    evt->setAddresses = p2_setAddresses;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_MULTICAST_ADDRESS_IND_ID);\
}

/* -------------------------- UNIFI_SYS_MULTICAST_ADDRESS.response -------------------------- */
typedef struct UnifiSysMulticastAddressRsp_Evt
{
    FsmEvent common;
    unifi_Status status;
    unifi_ListAction action;
    unifi_MulticastAddressList getAddresses;
} UnifiSysMulticastAddressRsp_Evt;

#define send_unifi_sys_multicast_address_rsp(context, pid, p1_status, p2_action, p3_getAddresses) \
{ \
    UnifiSysMulticastAddressRsp_Evt *evt = (UnifiSysMulticastAddressRsp_Evt*) osa_malloc(sizeof(UnifiSysMulticastAddressRsp_Evt));\
    evt->status = p1_status;\
    evt->action = p2_action;\
    evt->getAddresses = p3_getAddresses;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_MULTICAST_ADDRESS_RSP_ID);\
}

#define send_unifi_sys_multicast_address_rsp_external(context, pid, p1_status, p2_action, p3_getAddresses) \
{ \
    UnifiSysMulticastAddressRsp_Evt *evt = (UnifiSysMulticastAddressRsp_Evt*) osa_malloc(sizeof(UnifiSysMulticastAddressRsp_Evt));\
    evt->status = p1_status;\
    evt->action = p2_action;\
    evt->getAddresses = p3_getAddresses;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_MULTICAST_ADDRESS_RSP_ID);\
}

/* -------------------------- UNIFI_SYS_TCLAS_ADD.request -------------------------- */
typedef struct UnifiSysTclasAddReq_Evt
{
    FsmEvent common;
    unifi_DataBlock tclas;
} UnifiSysTclasAddReq_Evt;

#define send_unifi_sys_tclas_add_req(context, pid, p1_tclas) \
{ \
    UnifiSysTclasAddReq_Evt *evt = (UnifiSysTclasAddReq_Evt*) osa_malloc(sizeof(UnifiSysTclasAddReq_Evt));\
    evt->tclas = p1_tclas;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_TCLAS_ADD_REQ_ID);\
}

#define send_unifi_sys_tclas_add_req_external(context, pid, p1_tclas) \
{ \
    UnifiSysTclasAddReq_Evt *evt = (UnifiSysTclasAddReq_Evt*) osa_malloc(sizeof(UnifiSysTclasAddReq_Evt));\
    evt->tclas = p1_tclas;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_TCLAS_ADD_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_TCLAS_ADD.confirm -------------------------- */
typedef struct UnifiSysTclasAddCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiSysTclasAddCfm_Evt;

#define send_unifi_sys_tclas_add_cfm(context, pid, p1_status) \
{ \
    UnifiSysTclasAddCfm_Evt *evt = (UnifiSysTclasAddCfm_Evt*) osa_malloc(sizeof(UnifiSysTclasAddCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_TCLAS_ADD_CFM_ID);\
}

#define send_unifi_sys_tclas_add_cfm_external(context, pid, p1_status) \
{ \
    UnifiSysTclasAddCfm_Evt *evt = (UnifiSysTclasAddCfm_Evt*) osa_malloc(sizeof(UnifiSysTclasAddCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_TCLAS_ADD_CFM_ID);\
}

/* -------------------------- UNIFI_SYS_TCLAS_DEL.request -------------------------- */
typedef struct UnifiSysTclasDelReq_Evt
{
    FsmEvent common;
    unifi_DataBlock tclas;
} UnifiSysTclasDelReq_Evt;

#define send_unifi_sys_tclas_del_req(context, pid, p1_tclas) \
{ \
    UnifiSysTclasDelReq_Evt *evt = (UnifiSysTclasDelReq_Evt*) osa_malloc(sizeof(UnifiSysTclasDelReq_Evt));\
    evt->tclas = p1_tclas;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_TCLAS_DEL_REQ_ID);\
}

#define send_unifi_sys_tclas_del_req_external(context, pid, p1_tclas) \
{ \
    UnifiSysTclasDelReq_Evt *evt = (UnifiSysTclasDelReq_Evt*) osa_malloc(sizeof(UnifiSysTclasDelReq_Evt));\
    evt->tclas = p1_tclas;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_TCLAS_DEL_REQ_ID);\
}

/* -------------------------- UNIFI_SYS_TCLAS_DEL.confirm -------------------------- */
typedef struct UnifiSysTclasDelCfm_Evt
{
    FsmEvent common;
    unifi_Status status;
} UnifiSysTclasDelCfm_Evt;

#define send_unifi_sys_tclas_del_cfm(context, pid, p1_status) \
{ \
    UnifiSysTclasDelCfm_Evt *evt = (UnifiSysTclasDelCfm_Evt*) osa_malloc(sizeof(UnifiSysTclasDelCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_TCLAS_DEL_CFM_ID);\
}

#define send_unifi_sys_tclas_del_cfm_external(context, pid, p1_status) \
{ \
    UnifiSysTclasDelCfm_Evt *evt = (UnifiSysTclasDelCfm_Evt*) osa_malloc(sizeof(UnifiSysTclasDelCfm_Evt));\
    evt->status = p1_status;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_TCLAS_DEL_CFM_ID);\
}

/* -------------------------- UNIFI_SYS_TRAFFIC_CLASSIFICATION.request -------------------------- */
typedef struct UnifiSysTrafficClassificationReq_Evt
{
    FsmEvent common;
    unifi_traffic_type type;
    uint16 period;
} UnifiSysTrafficClassificationReq_Evt;

#define send_unifi_sys_traffic_classification_req(context, pid, p1_type, p2_period) \
{ \
    UnifiSysTrafficClassificationReq_Evt *evt = (UnifiSysTrafficClassificationReq_Evt*) osa_malloc(sizeof(UnifiSysTrafficClassificationReq_Evt));\
    evt->type = p1_type;\
    evt->period = p2_period;\
    fsm_send_event(context, (FsmEvent*)evt, pid, UNIFI_SYS_TRAFFIC_CLASSIFICATION_REQ_ID);\
}

#define send_unifi_sys_traffic_classification_req_external(context, pid, p1_type, p2_period) \
{ \
    UnifiSysTrafficClassificationReq_Evt *evt = (UnifiSysTrafficClassificationReq_Evt*) osa_malloc(sizeof(UnifiSysTrafficClassificationReq_Evt));\
    evt->type = p1_type;\
    evt->period = p2_period;\
    fsm_send_event_external(context, (FsmEvent*)evt, pid, UNIFI_SYS_TRAFFIC_CLASSIFICATION_REQ_ID);\
}

#endif
